zoukankan      html  css  js  c++  java
  • LeetCode-860. Lemonade Change

    At a lemonade stand, each lemonade costs $5

    Customers are standing in a queue to buy from you, and order one at a time (in the order specified by bills).

    Each customer will only buy one lemonade and pay with either a $5$10, or $20 bill.  You must provide the correct change to each customer, so that the net transaction is that the customer pays $5.

    Note that you don't have any change in hand at first.

    Return true if and only if you can provide every customer with correct change.

    Example 1:

    Input: [5,5,5,10,20]
    Output: true
    Explanation: 
    From the first 3 customers, we collect three $5 bills in order.
    From the fourth customer, we collect a $10 bill and give back a $5.
    From the fifth customer, we give a $10 bill and a $5 bill.
    Since all customers got correct change, we output true.
    

    Example 2:

    Input: [5,5,10]
    Output: true
    

    Example 3:

    Input: [10,10]
    Output: false
    

    Example 4:

    Input: [5,5,10,10,20]
    Output: false
    Explanation: 
    From the first two customers in order, we collect two $5 bills.
    For the next two customers in order, we collect a $10 bill and give back a $5 bill.
    For the last customer, we can't give change of $15 back because we only have two $10 bills.
    Since not every customer received correct change, the answer is false.

    Note:

    • 0 <= bills.length <= 10000
    • bills[i] will be either 510, or 20.

    贪心 时间复杂度O(n)

    public boolean lemonadeChange(int[] bills) {//贪心 my
            int[] count=new int[3];//0为5,1为10,2为20,可用map代替
            for (int i = 0; i < bills.length; i++) {
                if(5==bills[i]){
                    count[0]++;
                }
                else if(10==bills[i]){
                    count[1]++;
                    if(0>=count[0]){
                        return false;
                    }
                    count[0]--;
                }
                else{
                    count[2]++;
                    if((0>=count[1]&&3>count[0])||(0>=count[0])){
                        return false;
                    }
                    if(0>=count[1]){
                        count[0]-=3;
                    }
                    else{
                        count[1]--;
                        count[0]--;
                    }
                }
            }
            return true;
        }

    简洁版

    public boolean lemonadeChange(int[] bills) {
            int five = 0, ten = 0;
            for (int i : bills) {
                if (i == 5) five++;
                else if (i == 10) {five--; ten++;}
                else if (ten > 0) {ten--; five--;}
                else five -= 3;
                if (five < 0) return false;
            }
            return true;
        }
  • 相关阅读:
    蓝桥杯国赛--四阶幻方清晰易懂(dfs+剪枝,stl)
    蓝桥杯---九宫重排(典型bfs)
    快速排序算法细致总结!!!
    Topsis优劣解距离分析法
    golang变量的定义
    golang
    erlang的优缺点
    mongrel代码注解
    取石块 解题报告
    军队 解题报告
  • 原文地址:https://www.cnblogs.com/zhacai/p/10596846.html
Copyright © 2011-2022 走看看